/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
)

// ServerInventoryPayload struct for ServerInventoryPayload
type ServerInventoryPayload struct {
	AutoRotate *bool `json:"auto_rotate,omitempty"`
	AutoRotateIntervalInDays *int32 `json:"auto_rotate_interval_in_days,omitempty"`
	AutoRotateRotationHour *int32 `json:"auto_rotate_rotation_hour,omitempty"`
	EnableRdpSra *bool `json:"enable_rdp_sra,omitempty"`
	MigrationTargetId *int64 `json:"migration_target_id,omitempty"`
	ServerTargetsPathTemplate *string `json:"server_targets_path_template,omitempty"`
	UserGroups *[]string `json:"user_groups,omitempty"`
	UsersIgnoreList *map[string]bool `json:"users_ignore_list,omitempty"`
	UsersRotatedSecretsPathTemplate *string `json:"users_rotated_secrets_path_template,omitempty"`
}

// NewServerInventoryPayload instantiates a new ServerInventoryPayload object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewServerInventoryPayload() *ServerInventoryPayload {
	this := ServerInventoryPayload{}
	return &this
}

// NewServerInventoryPayloadWithDefaults instantiates a new ServerInventoryPayload object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewServerInventoryPayloadWithDefaults() *ServerInventoryPayload {
	this := ServerInventoryPayload{}
	return &this
}

// GetAutoRotate returns the AutoRotate field value if set, zero value otherwise.
func (o *ServerInventoryPayload) GetAutoRotate() bool {
	if o == nil || o.AutoRotate == nil {
		var ret bool
		return ret
	}
	return *o.AutoRotate
}

// GetAutoRotateOk returns a tuple with the AutoRotate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServerInventoryPayload) GetAutoRotateOk() (*bool, bool) {
	if o == nil || o.AutoRotate == nil {
		return nil, false
	}
	return o.AutoRotate, true
}

// HasAutoRotate returns a boolean if a field has been set.
func (o *ServerInventoryPayload) HasAutoRotate() bool {
	if o != nil && o.AutoRotate != nil {
		return true
	}

	return false
}

// SetAutoRotate gets a reference to the given bool and assigns it to the AutoRotate field.
func (o *ServerInventoryPayload) SetAutoRotate(v bool) {
	o.AutoRotate = &v
}

// GetAutoRotateIntervalInDays returns the AutoRotateIntervalInDays field value if set, zero value otherwise.
func (o *ServerInventoryPayload) GetAutoRotateIntervalInDays() int32 {
	if o == nil || o.AutoRotateIntervalInDays == nil {
		var ret int32
		return ret
	}
	return *o.AutoRotateIntervalInDays
}

// GetAutoRotateIntervalInDaysOk returns a tuple with the AutoRotateIntervalInDays field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServerInventoryPayload) GetAutoRotateIntervalInDaysOk() (*int32, bool) {
	if o == nil || o.AutoRotateIntervalInDays == nil {
		return nil, false
	}
	return o.AutoRotateIntervalInDays, true
}

// HasAutoRotateIntervalInDays returns a boolean if a field has been set.
func (o *ServerInventoryPayload) HasAutoRotateIntervalInDays() bool {
	if o != nil && o.AutoRotateIntervalInDays != nil {
		return true
	}

	return false
}

// SetAutoRotateIntervalInDays gets a reference to the given int32 and assigns it to the AutoRotateIntervalInDays field.
func (o *ServerInventoryPayload) SetAutoRotateIntervalInDays(v int32) {
	o.AutoRotateIntervalInDays = &v
}

// GetAutoRotateRotationHour returns the AutoRotateRotationHour field value if set, zero value otherwise.
func (o *ServerInventoryPayload) GetAutoRotateRotationHour() int32 {
	if o == nil || o.AutoRotateRotationHour == nil {
		var ret int32
		return ret
	}
	return *o.AutoRotateRotationHour
}

// GetAutoRotateRotationHourOk returns a tuple with the AutoRotateRotationHour field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServerInventoryPayload) GetAutoRotateRotationHourOk() (*int32, bool) {
	if o == nil || o.AutoRotateRotationHour == nil {
		return nil, false
	}
	return o.AutoRotateRotationHour, true
}

// HasAutoRotateRotationHour returns a boolean if a field has been set.
func (o *ServerInventoryPayload) HasAutoRotateRotationHour() bool {
	if o != nil && o.AutoRotateRotationHour != nil {
		return true
	}

	return false
}

// SetAutoRotateRotationHour gets a reference to the given int32 and assigns it to the AutoRotateRotationHour field.
func (o *ServerInventoryPayload) SetAutoRotateRotationHour(v int32) {
	o.AutoRotateRotationHour = &v
}

// GetEnableRdpSra returns the EnableRdpSra field value if set, zero value otherwise.
func (o *ServerInventoryPayload) GetEnableRdpSra() bool {
	if o == nil || o.EnableRdpSra == nil {
		var ret bool
		return ret
	}
	return *o.EnableRdpSra
}

// GetEnableRdpSraOk returns a tuple with the EnableRdpSra field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServerInventoryPayload) GetEnableRdpSraOk() (*bool, bool) {
	if o == nil || o.EnableRdpSra == nil {
		return nil, false
	}
	return o.EnableRdpSra, true
}

// HasEnableRdpSra returns a boolean if a field has been set.
func (o *ServerInventoryPayload) HasEnableRdpSra() bool {
	if o != nil && o.EnableRdpSra != nil {
		return true
	}

	return false
}

// SetEnableRdpSra gets a reference to the given bool and assigns it to the EnableRdpSra field.
func (o *ServerInventoryPayload) SetEnableRdpSra(v bool) {
	o.EnableRdpSra = &v
}

// GetMigrationTargetId returns the MigrationTargetId field value if set, zero value otherwise.
func (o *ServerInventoryPayload) GetMigrationTargetId() int64 {
	if o == nil || o.MigrationTargetId == nil {
		var ret int64
		return ret
	}
	return *o.MigrationTargetId
}

// GetMigrationTargetIdOk returns a tuple with the MigrationTargetId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServerInventoryPayload) GetMigrationTargetIdOk() (*int64, bool) {
	if o == nil || o.MigrationTargetId == nil {
		return nil, false
	}
	return o.MigrationTargetId, true
}

// HasMigrationTargetId returns a boolean if a field has been set.
func (o *ServerInventoryPayload) HasMigrationTargetId() bool {
	if o != nil && o.MigrationTargetId != nil {
		return true
	}

	return false
}

// SetMigrationTargetId gets a reference to the given int64 and assigns it to the MigrationTargetId field.
func (o *ServerInventoryPayload) SetMigrationTargetId(v int64) {
	o.MigrationTargetId = &v
}

// GetServerTargetsPathTemplate returns the ServerTargetsPathTemplate field value if set, zero value otherwise.
func (o *ServerInventoryPayload) GetServerTargetsPathTemplate() string {
	if o == nil || o.ServerTargetsPathTemplate == nil {
		var ret string
		return ret
	}
	return *o.ServerTargetsPathTemplate
}

// GetServerTargetsPathTemplateOk returns a tuple with the ServerTargetsPathTemplate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServerInventoryPayload) GetServerTargetsPathTemplateOk() (*string, bool) {
	if o == nil || o.ServerTargetsPathTemplate == nil {
		return nil, false
	}
	return o.ServerTargetsPathTemplate, true
}

// HasServerTargetsPathTemplate returns a boolean if a field has been set.
func (o *ServerInventoryPayload) HasServerTargetsPathTemplate() bool {
	if o != nil && o.ServerTargetsPathTemplate != nil {
		return true
	}

	return false
}

// SetServerTargetsPathTemplate gets a reference to the given string and assigns it to the ServerTargetsPathTemplate field.
func (o *ServerInventoryPayload) SetServerTargetsPathTemplate(v string) {
	o.ServerTargetsPathTemplate = &v
}

// GetUserGroups returns the UserGroups field value if set, zero value otherwise.
func (o *ServerInventoryPayload) GetUserGroups() []string {
	if o == nil || o.UserGroups == nil {
		var ret []string
		return ret
	}
	return *o.UserGroups
}

// GetUserGroupsOk returns a tuple with the UserGroups field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServerInventoryPayload) GetUserGroupsOk() (*[]string, bool) {
	if o == nil || o.UserGroups == nil {
		return nil, false
	}
	return o.UserGroups, true
}

// HasUserGroups returns a boolean if a field has been set.
func (o *ServerInventoryPayload) HasUserGroups() bool {
	if o != nil && o.UserGroups != nil {
		return true
	}

	return false
}

// SetUserGroups gets a reference to the given []string and assigns it to the UserGroups field.
func (o *ServerInventoryPayload) SetUserGroups(v []string) {
	o.UserGroups = &v
}

// GetUsersIgnoreList returns the UsersIgnoreList field value if set, zero value otherwise.
func (o *ServerInventoryPayload) GetUsersIgnoreList() map[string]bool {
	if o == nil || o.UsersIgnoreList == nil {
		var ret map[string]bool
		return ret
	}
	return *o.UsersIgnoreList
}

// GetUsersIgnoreListOk returns a tuple with the UsersIgnoreList field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServerInventoryPayload) GetUsersIgnoreListOk() (*map[string]bool, bool) {
	if o == nil || o.UsersIgnoreList == nil {
		return nil, false
	}
	return o.UsersIgnoreList, true
}

// HasUsersIgnoreList returns a boolean if a field has been set.
func (o *ServerInventoryPayload) HasUsersIgnoreList() bool {
	if o != nil && o.UsersIgnoreList != nil {
		return true
	}

	return false
}

// SetUsersIgnoreList gets a reference to the given map[string]bool and assigns it to the UsersIgnoreList field.
func (o *ServerInventoryPayload) SetUsersIgnoreList(v map[string]bool) {
	o.UsersIgnoreList = &v
}

// GetUsersRotatedSecretsPathTemplate returns the UsersRotatedSecretsPathTemplate field value if set, zero value otherwise.
func (o *ServerInventoryPayload) GetUsersRotatedSecretsPathTemplate() string {
	if o == nil || o.UsersRotatedSecretsPathTemplate == nil {
		var ret string
		return ret
	}
	return *o.UsersRotatedSecretsPathTemplate
}

// GetUsersRotatedSecretsPathTemplateOk returns a tuple with the UsersRotatedSecretsPathTemplate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServerInventoryPayload) GetUsersRotatedSecretsPathTemplateOk() (*string, bool) {
	if o == nil || o.UsersRotatedSecretsPathTemplate == nil {
		return nil, false
	}
	return o.UsersRotatedSecretsPathTemplate, true
}

// HasUsersRotatedSecretsPathTemplate returns a boolean if a field has been set.
func (o *ServerInventoryPayload) HasUsersRotatedSecretsPathTemplate() bool {
	if o != nil && o.UsersRotatedSecretsPathTemplate != nil {
		return true
	}

	return false
}

// SetUsersRotatedSecretsPathTemplate gets a reference to the given string and assigns it to the UsersRotatedSecretsPathTemplate field.
func (o *ServerInventoryPayload) SetUsersRotatedSecretsPathTemplate(v string) {
	o.UsersRotatedSecretsPathTemplate = &v
}

func (o ServerInventoryPayload) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.AutoRotate != nil {
		toSerialize["auto_rotate"] = o.AutoRotate
	}
	if o.AutoRotateIntervalInDays != nil {
		toSerialize["auto_rotate_interval_in_days"] = o.AutoRotateIntervalInDays
	}
	if o.AutoRotateRotationHour != nil {
		toSerialize["auto_rotate_rotation_hour"] = o.AutoRotateRotationHour
	}
	if o.EnableRdpSra != nil {
		toSerialize["enable_rdp_sra"] = o.EnableRdpSra
	}
	if o.MigrationTargetId != nil {
		toSerialize["migration_target_id"] = o.MigrationTargetId
	}
	if o.ServerTargetsPathTemplate != nil {
		toSerialize["server_targets_path_template"] = o.ServerTargetsPathTemplate
	}
	if o.UserGroups != nil {
		toSerialize["user_groups"] = o.UserGroups
	}
	if o.UsersIgnoreList != nil {
		toSerialize["users_ignore_list"] = o.UsersIgnoreList
	}
	if o.UsersRotatedSecretsPathTemplate != nil {
		toSerialize["users_rotated_secrets_path_template"] = o.UsersRotatedSecretsPathTemplate
	}
	return json.Marshal(toSerialize)
}

type NullableServerInventoryPayload struct {
	value *ServerInventoryPayload
	isSet bool
}

func (v NullableServerInventoryPayload) Get() *ServerInventoryPayload {
	return v.value
}

func (v *NullableServerInventoryPayload) Set(val *ServerInventoryPayload) {
	v.value = val
	v.isSet = true
}

func (v NullableServerInventoryPayload) IsSet() bool {
	return v.isSet
}

func (v *NullableServerInventoryPayload) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableServerInventoryPayload(val *ServerInventoryPayload) *NullableServerInventoryPayload {
	return &NullableServerInventoryPayload{value: val, isSet: true}
}

func (v NullableServerInventoryPayload) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableServerInventoryPayload) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


